# nulib\schema

* implémenter support `analyzer_func`, `extractor_func`, `parser_func`,
  `normalizer_func`, `formatter_func`
* dans la définition, `[type]` est remplacé par l'instance de IType lors de sa
  résolution?
* implémenter l'instanciation de types avec des paramètres particuliers. *si*
  des paramètres sont fournis, le type est instancié avec la signature 
  `IType($typeDefinition, $schemaDefinition)` e.g
  ~~~php
  const SCHEMA = ["type", default, "required" => true];
  # le type est instancié comme suit:
  $type = new ttype();
  
  const SCHEMA = [[["type", ...]], default, "required" => true];
  # le type est instancié comme suit:
  # le tableau peut être une liste ou associatif, c'est au type de décider ce 
  # qu'il en fait
  $type = new ttype(["type", ...], SCHEMA);
  ~~~
* ajouter à IType les méthodes getName() pour le nom officiel du type,
  getAliases() pour les alias supportés, et getClass() pour la définition de la
  classe dans les méthodes et propriétés
  getName() et getAliases() sont juste pour information, ils ne sont pas utilisés
  lors de la résolution du type effectif.
* si cela a du sens, dans AssocSchema, n'instancier les schémas de chaque clé qu'à la demande.
  l'idée est de ne pas perdre du temps à instancier un schéma qui ne serait pas utilisé

  on pourrait avoir d'une manière générale quelque chose comme:
  ~~~
  Schema::ensure(&$schema, ?array $def=null, $defKey=null): Schema;
  ~~~
  * si $schema est une instance de Schema, la retourner
  * si c'est un array, c'est une définition et il faut la remplacer par l'instance de Schema correspondant
  * sinon, prendre $def comme définition
  $key est la clé si $schema est dans un autre schema

-*- coding: utf-8 mode: markdown -*- vim:sw=4:sts=4:et:ai:si:sta:fenc=utf-8:noeol:binary